const tipoRemover = '0';
const mensagem = 'Existe um histórico de alteração Salarial com as mesmas caracteristicas dos parâmetros atuais aguardando efetivação. Deseja utilizar o existente?';
FormManager.afterCreateAllForms.subscribe(function () {
    let form = FormManager.byname('TnFpaDPReajustePercentParams', '');

    if (WizardManager.context.DetalheAtivo.toUpperCase() === form.nome.toUpperCase()) {
        WizardManager.setCustomEvent('TnFpaDPReajustePercentParams', function (item) {
            if (form.getvalue('PTIPOREAJUSTE') === tipoRemover) {
                removerHistoricoSalarial();
            } else {
                verificaReutilizarCodiogReajuste(item);
            }
        });
    }

    function removerHistoricoSalarial() {
        AJaxProcessoExecuteMethodGetProperty({
            _AClass: 'TnFpaDPReajustePercentParams',
            _AMethodName: 'ExecutaRemover',
            _AValues: JSON.stringify(form.getValues()),
            _ANamePropertys: '',
            onSuccess: (retorno) => {
                if (retorno.data.result) {
                    criarDialogOk('Processo de limpeza executado com sucesso!', 'Aviso');
                }
            }
        });
    }

    function verificaReutilizarCodiogReajuste(item) {
        let params = JSON.stringify({
            'pTipoReajuste': form.getvalue('pTIPOREAJUSTE'),
            'pCodigoLote': form.getvalue('pCODIGOLOTE'),
            'pEmpresas': form.getvalue('pEMPRESAS'),
            'pData': new Date(form.getvalue('pDATA')).toLocaleDateString('pt-BR', { timeZone: 'UTC' })
        });

        AJaxProcessoExecuteMethodGetProperty({
            _AClass: 'TnFpaDPReajustePercentParams',
            _AMethodName: 'ReutilizarCodReajusteSalConfPorData',
            _AValues: params,
            _ANamePropertys: '',
            onSuccess: (retorno) => {
                if (retorno.data.result.codigoReajuste > 0) {
                    criarDialogSimNao(mensagem, "Confirma execução",
                        () => { GoToWizardItem('TNFPADPREAJUSTEPERCENTRASCUNHO') },
                        () => { GoToWizardItem(item) });
                } else {
                    GoToWizardItem(item);
                }
            }
        });
    }
});
