FormManager.afterCreateAllForms.subscribe(function () {
    let form = FormManager.byname('TnfpaDPRecalculoImp', '');
    let adm = Boolean;
    let recalcularRefEvento = Boolean;

    configurarOpcoesFiltro();

    function configurarOpcoesFiltro() {
        let Executor = new nExpressionExecutor();
        Executor.execute('EXTERNO("EHADMINISTRADOR",[])').then((ehAdministrador) => {
            adm = ehAdministrador;
            setEnabledCheckbox(form, 'OPCOESFILTRO', '1', ehAdministrador, false);
            setEnabledCheckbox(form, 'OPCOESFILTRO', '2', ehAdministrador, false);
            setEnabledCheckbox(form, 'OPCOESFILTRO', '4', ehAdministrador, false);
            setEnabledCheckbox(form, 'OPCOESFILTRO', '8', ehAdministrador, false);
            setEnabledCheckbox(form, 'OPCOESFILTRO', '128', ehAdministrador, false);
            setEnabledCheckbox(form, 'OPCOESFILTRO', '32', ehAdministrador, false);
            setEnabledCheckbox(form, 'OPCOESFILTRO', '64', ehAdministrador, false);
        });
    }

    $('#ctrlOPCOESFILTROcheck').change(configurarCheckOpcoesFiltro);
    form.getcomponent('pTIPOCORRECAO').change(DoChange);
    form.getcomponent('pTIPOCORRECAO').blur(DoChange);

    function DoChange() {
        console.log('teste')
        if ((form.fieldbyName('pTIPOCORRECAO').getvalue() == 3 || form.fieldbyName('pTIPOCORRECAO').getvalue() == 4)) {
            form.setenabled('pAlterarValorExistente', true)
            form.setrequired('pAlterarValorExistente', true)
        } else {
            form.setenabled('pAlterarValorExistente', false)
            form.setrequired('pAlterarValorExistente', false)
        }
    };

    let Executor = new nExpressionExecutor();
    Executor.execute('EXTERNO("RECALCULARREFERENCIAEVENTO",[])').then((recalcularReferenciaEvento) => {
        recalcularRefEvento = recalcularReferenciaEvento;
    });

    form.setenabled('PeriodoInicial', false);
    form.setenabled('PeriodoFinal', false);
    form.setenabled('Compete', false);
    form.setenabled('DataPgto', false);
    form.setenabled('TipoDctoCompl', false);
    form.setenabled('CodigoPerCalcCompl', false);
    form.setenabled('pTipoCorrecao', false);
    form.setenabled('pAlterarValorExistente', false);
    form.setenabled('pEVENTOS', false);

    function configurarCheckOpcoesFiltro() {
        if (((isChecked('OPCOESFILTRO', '1')) ||
            (isChecked('OPCOESFILTRO', '2')) ||
            (isChecked('OPCOESFILTRO', '4')) ||
            (isChecked('OPCOESFILTRO', '8')) ||
            (isChecked('OPCOESFILTRO', '128')) ||
            (isChecked('OPCOESFILTRO', '32')) ||
            (isChecked('OPCOESFILTRO', '64'))) && !(adm)) {
            setEnabledCheckbox(form, 'OPCOESFILTRO', '1', true, false)
            setEnabledCheckbox(form, 'OPCOESFILTRO', '2', true, false)
            setEnabledCheckbox(form, 'OPCOESFILTRO', '4', true, false)
            setEnabledCheckbox(form, 'OPCOESFILTRO', '8', true, false)
            setEnabledCheckbox(form, 'OPCOESFILTRO', '128', true, false)
            setEnabledCheckbox(form, 'OPCOESFILTRO', '32', true, false)
            setEnabledCheckbox(form, 'OPCOESFILTRO', '64', true, false)
            qNotifier.error('Este processo é permitido para usuários do grupo Administrador, para utilização durante o período de conversão ou migração dos dados de outros sistema.\nSomente a opção: Recalcular INSS Desoneração está disponível para os usuários de outros grupos.');
        }

        if (isChecked('OPCOESFILTRO', '32')) {
            setEnabledCheckbox(form, 'OPCOESFILTRO', '1', true, false)
            setEnabledCheckbox(form, 'OPCOESFILTRO', '2', true, false)
            setEnabledCheckbox(form, 'OPCOESFILTRO', '4', true, false)
            setEnabledCheckbox(form, 'OPCOESFILTRO', '8', true, false)
            setEnabledCheckbox(form, 'OPCOESFILTRO', '128', true, false)
            setEnabledCheckbox(form, 'OPCOESFILTRO', '64', true, false)
        } else if ((isChecked('OPCOESFILTRO', '1')) ||
            (isChecked('OPCOESFILTRO', '2')) ||
            (isChecked('OPCOESFILTRO', '4')) ||
            (isChecked('OPCOESFILTRO', '8')) ||
            (isChecked('OPCOESFILTRO', '128')) ||
            (isChecked('OPCOESFILTRO', '16')) ||
            (isChecked('OPCOESFILTRO', '64'))) {
            setEnabledCheckbox(form, 'OPCOESFILTRO', '32', true, false)
        }

        if ((isChecked('OPCOESFILTRO', '64')) && !(recalcularRefEvento)) {
            setEnabledCheckbox(form, 'OPCOESFILTRO', '64', true, false)
            qNotifier.error('Usuário não tem permissão para executar esta opção!');
        }

        let ativar = isChecked('OPCOESFILTRO', '64');
        form.setenabled('pTIPOCORRECAO', ativar)
        form.setenabled('pEVENTOS', ativar)

        if ((form.fieldbyName('pTIPOCORRECAO').getvalue() == 3 || form.fieldbyName('pTIPOCORRECAO').getvalue() == 4) && ativar) {
            form.setenabled('pAlterarValorExistente', true)
            form.setrequired('pAlterarValorExistente', true)
        } else {
            form.setenabled('pAlterarValorExistente', false)
            form.setrequired('pAlterarValorExistente', true)
        }
    };
});

function setEnabledCheckbox(form, fieldName, checkboxName, isEnabled, isChecked) {
    form.fieldbyName(`${fieldName}_checkbox_${checkboxName}`).setenabled(isEnabled);
    document.getElementById(`ctrl${fieldName}_checkbox_${checkboxName}_ctrl${fieldName}`).checked = isChecked;
}

function isChecked(fieldName, checkboxName) {
    return document.getElementById(`ctrl${fieldName}_checkbox_${checkboxName}_ctrl${fieldName}`).checked;
};
