{
    FormManager.afterCreateAllForms.subscribe(() => {
        const form = FormManager.byname('TnGemDPManutencaoDados');
        const requiredFields = App.getDefinicaoObjetos('TnGemDPManutencaoDados').Fields.find(({ Name }) => Name == 'PCAMPOSOBRIGATORIOS').Valor.split(';');
        const pCamposSelecionados = 'PCAMPOSSELECIONADOS';

        form.afterCreateStaticFields.subscribe(() => {
            requiredFields.forEach((fieldIndex) => {
                const nvValue = Number(fieldIndex) + 1;

                form.setfieldvalue(`${pCamposSelecionados}_checkbox_${nvValue}`, true);
                form.setenabledCheckListBoxItem(pCamposSelecionados, nvValue, false);
            });

            form.setvisible('PCLASSEDM', false);

            setFullHeightSelecteFields(form);
        });

        tabEl('Dados').hide();

        form.AfterExecuteActionProcess.subscribe(() => {
            tabEl('Filtros').hide();
            tabEl('Campos').hide();
            tabEl('Dados').show();
            tabEl('Dados').tab('show');

            form.setActionVisible('ActionExecutarExecute', false);
        });

        setFullHeight();
    });

    function tabEl(tabText) {
        return $(`a[data-toggle="tab"]:contains("${tabText}")`);
    }

    function setFullHeight() {
        $('.layout-component .form-fields').each((index, el) => {
            const parents = $(el).parents().map((index, el) => $(el));

            for (const $parent of parents) {
                if ($parent.is('.card, .row, .layout-component')) {
                    $parent.addClass('h-100')
                }

                if ($parent.hasClass('layout-component')) break;
            }
        });
    }

    function setFullHeightSelecteFields(form) {
        const checkbox = form.fields.find((field) => field.nome.match(/camposselecionados_checkbox/i));

        if (!checkbox) return;

        const checkboxWrapper = checkbox.componente.closest('.checkbox-wrapper');
        const inputBlock = checkboxWrapper.closest('.input-block');

        checkboxWrapper.css({
            'column-count': '3',
            'max-height': 'none'
        });

        inputBlock
            .toggleClass('col-12', true)
            .toggleClass('col-md-4', false);


        (new MutationObserver((_, observer) => {
            if (!checkboxWrapper.hasClass('ps')) return;

            observer.disconnect();

            const scroll = KTUtil.data(checkboxWrapper.get(0)).get('ps');

            if (scroll) {
                scroll.destroy();
            }
        })).observe(checkboxWrapper.get(0), { attributes: true });
    }
}